package io.tswf.minecraft.metamorphosis.core.exception

import groovy.transform.CompileStatic

@CompileStatic
class FileHooksReadingException extends RuntimeException {
    File file

    FileHooksReadingException(File file) {
        super(getExceptionMessage(file))
        this.file = file
    }

    FileHooksReadingException(String message, File file) {
        super(getExceptionMessage(file, message))
        this.file = file
    }

    FileHooksReadingException(String message, Throwable cause, File file) {
        super(getExceptionMessage(file, message), cause)
        this.file = file
    }

    FileHooksReadingException(Throwable cause, File file) {
        super(getExceptionMessage(file), cause)
        this.file = file
    }

    static String getExceptionMessage(File file, String message = "") {
        return "Exception occurred while reading file hooks from ${file?.absoluteCanonicalFile?.path}: ${message}"
    }
}
