package io.tswf.minecraft.metamorphosis.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.metamorphosis.core.scanning.IFilesToScanProvider

@CompileStatic
class FilesToScanProvidingException extends RuntimeException {
    IFilesToScanProvider filesToScanProvider

    FilesToScanProvidingException(IFilesToScanProvider filesToScanProvider) {
        super(getExceptionMessage(filesToScanProvider))
        this.filesToScanProvider = filesToScanProvider
    }

    FilesToScanProvidingException(String message, IFilesToScanProvider filesToScanProvider) {
        super(getExceptionMessage(filesToScanProvider, message))
        this.filesToScanProvider = filesToScanProvider
    }

    FilesToScanProvidingException(String message, Throwable cause, IFilesToScanProvider filesToScanProvider) {
        super(getExceptionMessage(filesToScanProvider, message), cause)
        this.filesToScanProvider = filesToScanProvider
    }

    FilesToScanProvidingException(Throwable cause, IFilesToScanProvider filesToScanProvider) {
        super(getExceptionMessage(filesToScanProvider), cause)
        this.filesToScanProvider = filesToScanProvider
    }

    static String getExceptionMessage(IFilesToScanProvider filesToScanProvider, String message = "") {
        return "Exception occurred while trying to provide files to scan by ${filesToScanProvider}: ${message}"
    }
}
