package io.tswf.minecraft.metamorphosis.core.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.metamorphosis.core.remap.ITinyRemapperConfigurationListener

@CompileStatic
class TinyRemapperAdapterConfigurationListenerException extends RuntimeException {

    ITinyRemapperConfigurationListener listener

    TinyRemapperAdapterConfigurationListenerException(ITinyRemapperConfigurationListener listener) {
        super(getExceptionMessage(listener))
        this.listener = listener
    }

    TinyRemapperAdapterConfigurationListenerException(String message, ITinyRemapperConfigurationListener listener) {
        super(getExceptionMessage(listener, message))
        this.listener = listener
    }

    TinyRemapperAdapterConfigurationListenerException(String message, Throwable cause, ITinyRemapperConfigurationListener listener) {
        super(getExceptionMessage(listener, message), cause)
        this.listener = listener
    }

    TinyRemapperAdapterConfigurationListenerException(Throwable cause, ITinyRemapperConfigurationListener listener) {
        super(getExceptionMessage(listener), cause)
        this.listener = listener
    }

    static String getExceptionMessage(ITinyRemapperConfigurationListener listener, String message = "") {
        return "Exception occurred while trying to listen tiny remapper configuration by listener '${listener}': ${message}"
    }
}
