package io.tswf.minecraft.metamorphosis.core.model

import groovy.transform.CompileStatic

@CompileStatic
class HooksInfo {
    Set<String> transmutations = new TreeSet<>()
    Set<String> views = new TreeSet<>()
    Set<String> staticViews = new TreeSet<>()
    Set<String> expansions = new TreeSet<>()

    Map<String, byte[]> classNameToBytes = new HashMap<>()

    void addAll(HooksInfo anotherHooks) {
        if (anotherHooks != this) {
            anotherHooks?.transmutations?.let {
                transmutations.addAll(it)
            }

            anotherHooks?.views?.let {
                views.addAll(it)
            }

            anotherHooks?.expansions?.let {
                expansions.addAll(it)
            }

            anotherHooks?.staticViews?.let {
                staticViews.addAll(it)
            }

            anotherHooks?.classNameToBytes?.let {
                classNameToBytes.putAllIfAbsent(it)
            }
        }
    }
}
